/* g++ -DLINUX examples/about_example.cpp  -lcc-aux2 -pthread -ldl */
#include <About.h>
#include <assert.h>
#include <iostream>

using namespace std;
using namespace CrossControl;

void list_about_information(ABOUTHANDLE pAbout)
{
  if (!pAbout)
    return;

  size_t const buffer_len = 256;
  char* buffer = new (nothrow) char[buffer_len];
  unsigned char major,minor;

  if (!buffer)
    return;

  CrossControl::eErr err;

  //! [Calling About_hasOsBooted]
  bool isBootComplete;
  err = CrossControl::About_hasOsBooted(pAbout, &isBootComplete);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "System bootup complete: " << (isBootComplete ? "YES" : "NO") << endl;
  //! [Calling About_hasOsBooted]

  //! [Calling About_getMainPCBSerial]
  err = About_getMainPCBSerial (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Main PCB serial: " << buffer << endl;
  //! [Calling About_getMainPCBSerial]

  //! [Calling About_getMainPCBArt]
  err = About_getMainPCBArt (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Main PCB article number: " << buffer << endl;
  //! [Calling About_getMainPCBArt]

  //! [Calling About_getUnitSerial]
  err = About_getUnitSerial (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Unit serial: " << buffer << endl;
  //! [Calling About_getUnitSerial]

  //! [Calling About_getMainManufacturingDate]
  err = About_getMainManufacturingDate (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Manufacturing date: " << buffer << endl;
  //! [Calling About_getMainManufacturingDate]

  //! [Calling About_getMainHWversion]
  err = About_getMainHWversion (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Main hardware version: " << buffer << endl;
  //! [Calling About_getMainHWversion]

  //! [Calling About_getMainProdRev]
  err = About_getMainProdRev (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Main product revision: " << buffer << endl;
  //! [Calling About_getMainProdRev]

  //! [Calling About_getMainProdArtNr]
  err = About_getMainProdArtNr (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Main product article number: " << buffer << endl;
  //! [Calling About_getMainProdArtNr]

  //! [Calling About_getDisplayResolution]
  err = About_getDisplayResolution (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Display resolution: " << buffer << endl;
  //! [Calling About_getDisplayResolution]

  //! [Calling About_getAddOnPCBSerial]
  err = About_getAddOnPCBSerial (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Add on PCB serial number: " << buffer << endl;
  //! [Calling About_getAddOnPCBSerial]

  //! [Calling About_getAddOnPCBArt]
  err = About_getAddOnPCBArt (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Add on PCB article number: " << buffer << endl;
  //! [Calling About_getAddOnPCBArt]

  //! [Calling About_getAddOnManufacturingDate]
  err = About_getAddOnManufacturingDate (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Add on manufacturing date: " << buffer << endl;
  //! [Calling About_getAddOnManufacturingDate]

  //! [Calling About_getAddOnHWversion]
  err = About_getAddOnHWversion (pAbout, buffer, buffer_len);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Add on hardware version: " << buffer << endl;
  //! [Calling About_getAddOnHWversion]

  //! [Calling About_getNrOfETHConnections]
  unsigned char nrOfEthConnections;
  err = About_getNrOfETHConnections (pAbout, &nrOfEthConnections);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of ethernet connections: " << (int)nrOfEthConnections << endl;
  //! [Calling About_getNrOfETHConnections]

  //! [Calling About_getNrOfCANConnections]
  unsigned char nrOfCANConnections;
  err = About_getNrOfCANConnections (pAbout, &nrOfCANConnections);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of CAN connections: " << (int)nrOfCANConnections << endl;
  //! [Calling About_getNrOfCANConnections]

  //! [Calling About_getNrOfVideoConnections]
  unsigned char nrOfVideoConnections;
  err = About_getNrOfVideoConnections (pAbout, &nrOfVideoConnections);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of video connections: " << (int)nrOfVideoConnections << endl;
  //! [Calling About_getNrOfVideoConnections]

  //! [Calling About_getNrOfUSBConnections]
  unsigned char nrOfUSBConnections;
  err = About_getNrOfUSBConnections (pAbout, &nrOfUSBConnections);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of USB connections: " << (int)nrOfUSBConnections << endl;
  //! [Calling About_getNrOfUSBConnections]

  //! [Calling About_getNrOfSerialConnections]
  unsigned char nrOfSerialConnections;
  err = About_getNrOfSerialConnections (pAbout, &nrOfSerialConnections);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of serial connections: " << (int)nrOfSerialConnections << endl;
  //! [Calling About_getNrOfSerialConnections]

  //! [Calling About_getNrOfDigIOConnections]
  unsigned char nrOfDigIOConnections;
  err = About_getNrOfDigIOConnections (pAbout, &nrOfDigIOConnections);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of digital I/O connections: " << (int)nrOfDigIOConnections << endl;
  //! [Calling About_getNrOfDigIOConnections]

  //! [Calling About_getIsDisplayAvailable]
  bool displayAvailable;
  err = About_getIsDisplayAvailable (pAbout, &displayAvailable);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Display available: " << (displayAvailable ? "YES" : "NO") << endl;
  //! [Calling About_getIsDisplayAvailable]

  //! [Calling About_getIsTouchScreenAvailable]
  bool touchScreenAvailable;
  err = About_getIsTouchScreenAvailable (pAbout, &touchScreenAvailable);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "TouchScreen available: " << (touchScreenAvailable ? "YES" : "NO") << endl;
  //! [Calling About_getIsTouchScreenAvailable]

  //! [Calling About_getIsTouchScreenAvailable]
  bool pcbBluetoothAvailable;
  err = About_getIsPCBBluetoothAvailable (pAbout, &pcbBluetoothAvailable);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "PCB Bluetooth available: " << (pcbBluetoothAvailable ? "YES" : "NO") << endl;
  //! [Calling About_getIsTouchScreenAvailable]

  //! [Calling About_getNrOfCfgInConnections]
  unsigned char nrOfCfgIn;
  err = About_getNrOfCfgInConnections (pAbout, &nrOfCfgIn);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of configurable inputs: " << (int)nrOfCfgIn << endl;
  else if (CrossControl::ERR_NOT_SUPPORTED == err)
    cout << "About_getNrOfCfgInConnections: Not supported" << endl;
  //! [Calling About_getNrOfCfgInConnections]

  //! [Calling About_getNrOfPWMOutConnections]
  unsigned char nrOfPwmOut;
  err = About_getNrOfPWMOutConnections (pAbout, &nrOfPwmOut);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of PWM outputs: " << (int)nrOfPwmOut << endl;
  else if (CrossControl::ERR_NOT_SUPPORTED == err)
    cout << "About_getNrOfPWMOutConnections: Not supported" << endl;
  //! [Calling About_getNrOfPWMOutConnections]

  //! [Calling About_getNrOfButtons]
  int nrOfButtons;
  err = About_getNrOfButtons (pAbout, &nrOfButtons);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Nr of configurable buttons: " << (int)nrOfButtons << endl;
  else if (CrossControl::ERR_NOT_SUPPORTED == err)
    cout << "About_getNrOfButtons: Not supported" << endl;
  //! [Calling About_getNrOfButtons]

  //! [Calling About_getIsWLANMounted]
  bool isWLANMounted;
  err = About_getIsWLANMounted (pAbout, &isWLANMounted);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "WLAN mounted: " << (isWLANMounted ? "YES" : "NO") << endl;
  //! [Calling About_getIsWLANMounted]

  //! [Calling About_getIsGPSMounted]
  bool isGPSMounted;
  err = About_getIsGPSMounted (pAbout, &isGPSMounted);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "GPS mounted: " << (isGPSMounted ? "YES" : "NO") << endl;
  //! [Calling About_getIsGPSMounted]

  //! [Calling About_getIsGPRSMounted]
  bool isGPRSMounted;
  err = About_getIsGPRSMounted (pAbout, &isGPRSMounted);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "GPRS mounted: " << (isGPRSMounted ? "YES" : "NO") << endl;
  //! [Calling About_getIsGPRSMounted]

  //! [Calling About_getIsBTMounted]
  bool isBTMounted;
  err = About_getIsBTMounted (pAbout, &isBTMounted);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "BT mounted: " << (isBTMounted ? "YES" : "NO") << endl;
  //! [Calling About_getIsBTMounted]

  //! [Calling About_getFrontPcbRev]
  err = CrossControl::About_getFrontPcbRev(pAbout, &major, &minor);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "FrontPCBRevision: " << (int)major << "." << (int)minor << endl;
  //! [Calling About_getFrontPcbRev]

  //! [Calling About_getIsAnybusMounted]
  bool isAnybusMounted;
  err = CrossControl::About_getIsAnybusMounted(pAbout, &isAnybusMounted);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "Anybus mounted: " << (isAnybusMounted ? "YES" : "NO") << endl;
  //! [Calling About_getIsAnybusMounted]

  //! [Calling About_getIsIOExpanderMounted]
  bool isIOExpanderMounted;
  err = CrossControl::About_getIsIOExpanderMounted(pAbout, &isIOExpanderMounted);
  if (CrossControl::ERR_SUCCESS == err)
    cout << "IOExpander mounted: " << (isIOExpanderMounted ? "YES" : "NO") << endl;
  //! [Calling About_getIsIOExpanderMounted]

  delete[] buffer;
}

int main(void)
{
  //! [Calling About_release]
  //! [Calling GetAbout]
  ABOUTHANDLE pAbout = ::GetAbout();
  assert(pAbout);

  list_about_information(pAbout);

  About_release(pAbout);
  //! [Calling GetAbout]
  //! [Calling About_release]

  return 0;
}
