/* g++ -DLINUX examples/digio_example.cpp  -lcc-aux2 -pthread -ldl */
#include <assert.h>
#include <DigIO.h>
#include <iostream>

using namespace std;
using namespace CrossControl;

void list_digital_inputs(DIGIOHANDLE pDigIO)
{
  if (!pDigIO)
    return;

  CrossControl::eErr err;
  unsigned char inputs;

  //! [Calling DigIO_getDigIO]
  err = DigIO_getDigIO (pDigIO, &inputs);
  if (CrossControl::ERR_SUCCESS == err)
  {
    cout << "Digital In 1: " <<
         ((inputs & CrossControl::DigitalIn_1) ? "High" : "Low") << endl;
    cout << "Digital In 2: " <<
         ((inputs & CrossControl::DigitalIn_2) ? "High" : "Low") << endl;
    cout << "Digital In 3: " <<
         ((inputs & CrossControl::DigitalIn_3) ? "High" : "Low") << endl;
    cout << "Digital In 4: " <<
         ((inputs & CrossControl::DigitalIn_4) ? "High" : "Low") << endl;
  }
  else
  {
    cout << "Unable to read digital input status." << endl;
  }
  //! [Calling DigIO_getDigIO]

  //! [Calling DigIO_setDigIO]
  err = DigIO_setDigIO (pDigIO, inputs);
  if (CrossControl::ERR_SUCCESS == err)
  {
    cout << "Digital out set to the status read." << endl;
  }
  else
  {
    cout << "Unable to set digital output status." << endl;
  }
  //! [Calling DigIO_setDigIO]
}

int main(void)
{
  //! [Calling DigIO_release]
  //! [Calling GetDigIO]
  DIGIOHANDLE pDigIO = ::GetDigIO();
  assert(pDigIO);

  list_digital_inputs(pDigIO);

  DigIO_release(pDigIO);
  //! [Calling GetDigIO]
  //! [Calling DigIO_release]
  
  return 0;
}
