/************************************************
 *
 *  CROSSCONTROL AUX API
 *
 *  CCAuxErrors.h
 *
 *  Version 2.15.2.0, 2020-07-08
 *
 *  (c) CrossControl 2010-2020
 *

 *  File description: CCAux Error handling
 *
 ************************************************/

#ifndef CCAUXERROR_H_
#define CCAUXERROR_H_

#include "CCPlatform.h"
#include "CCAuxTypes.h"

#ifdef __cplusplus
namespace CrossControl
{
#endif

  /*! to get a string description.
  *
  * Get a string description of an error code.
  *
  * Supported Platform(s): XL, XM, XS, XA, VS, VI2
  *
  * @param errCode An error code for which to get a string description.
  *
  * @return String description of an error code.
  */
  EXTERN_C
    CCAUXDLL_API
    char_t const*
    CCAUXDLL_CALLING_CONV
    GetErrorStringA(eErr errCode);

  /*!
  * Get a string description of an error code.
  *
  * Supported Platform(s): XL, XM, XS, XA, VS, VI2
  *
  * @param errCode An error code for which
  *
  * @return String description of an error code.
  */
  EXTERN_C
    CCAUXDLL_API
    wchar_t const*
    CCAUXDLL_CALLING_CONV
    GetErrorStringW(eErr errCode);

#ifdef __cplusplus
}
#endif

#endif /* CCAUXERROR_H_ */

